---
 backport-include/asm/dma-mapping.h      |    2 ++
 backport-include/linux/device.h         |    2 ++
 backport-include/linux/etherdevice.h    |    4 ++++
 backport-include/linux/ethtool.h        |    2 ++
 backport-include/linux/fs.h             |    2 ++
 backport-include/linux/kernel.h         |    2 ++
 backport-include/linux/kref.h           |    2 ++
 backport-include/linux/mii.h            |    2 ++
 backport-include/linux/netdevice.h      |    2 ++
 backport-include/linux/pagemap.h        |    2 ++
 backport-include/linux/pci.h            |    2 ++
 backport-include/linux/skbuff.h         |    2 ++
 backport-include/linux/vga_switcheroo.h |    2 ++
 backport-include/linux/wait.h           |    2 ++
 backport-include/linux/watchdog.h       |    2 ++
 compat/compat-3.4.c                     |    4 ++++
 compat/compat-3.7.c                     |    4 ++++
 17 files changed, 40 insertions(+)

--- a/backport-include/asm/dma-mapping.h
+++ b/backport-include/asm/dma-mapping.h
@@ -10,6 +10,7 @@ dma_common_get_sgtable(struct device *de
 		       void *cpu_addr, dma_addr_t dma_addr, size_t size);
 #endif /* defined(CPTCFG_BACKPORT_BUILD_DMA_SHARED_HELPERS) */
 
+#if 0 /* XXX SP3 */
 #if LINUX_VERSION_CODE < KERNEL_VERSION(3,6,0)
 
 #define dma_get_sgtable_attrs LINUX_BACKPORT(dma_get_sgtable_attrs)
@@ -23,5 +24,6 @@ dma_get_sgtable_attrs(struct device *dev
 
 #define dma_get_sgtable(d, t, v, h, s) dma_get_sgtable_attrs(d, t, v, h, s, NULL)
 #endif /* LINUX_VERSION_CODE < KERNEL_VERSION(3,6,0) */
+#endif /* XXX SP3 */
 
 #endif /* __BACKPORT_ASM_DMA_MAPPING_H */
--- a/backport-include/linux/ethtool.h
+++ b/backport-include/linux/ethtool.h
@@ -3,12 +3,14 @@
 #include_next <linux/ethtool.h>
 #include <linux/version.h>
 
+#if 0 /* XXX SP3 */
 #if LINUX_VERSION_CODE < KERNEL_VERSION(3,3,0)
 static inline u32 ethtool_rxfh_indir_default(u32 index, u32 n_rx_rings)
 {
 	return index % n_rx_rings;
 }
 #endif
+#endif /* XXX SP3 */
 
 #ifndef ETHTOOL_FWVERS_LEN
 #define ETHTOOL_FWVERS_LEN 32
--- a/backport-include/linux/kernel.h
+++ b/backport-include/linux/kernel.h
@@ -42,6 +42,7 @@ extern const char hex_asc[];
 #define hex_asc_lo(x)	hex_asc[((x) & 0x0f)]
 #endif
 
+#if 0 /* XXX SP3 */
 #if LINUX_VERSION_CODE < KERNEL_VERSION(3,2,0)
 static inline char *hex_byte_pack(char *buf, u8 byte)
 {
@@ -50,6 +51,7 @@ static inline char *hex_byte_pack(char *
 	return buf;
 }
 #endif
+#endif /* XXX SP3 */
 
 /* This backports:
  *
--- a/backport-include/linux/pci.h
+++ b/backport-include/linux/pci.h
@@ -93,6 +93,7 @@ int __must_check pci_enable_device_mem(s
 		       pci_unregister_driver)
 #endif
 
+#if 0 /* XXX SP3 */
 #if LINUX_VERSION_CODE < KERNEL_VERSION(3,7,0)
 #define pcie_capability_read_word LINUX_BACKPORT(pcie_capability_read_word)
 int pcie_capability_read_word(struct pci_dev *dev, int pos, u16 *val);
@@ -133,6 +134,7 @@ static inline int pcie_capability_clear_
 	return pcie_capability_clear_and_set_dword(dev, pos, clear, 0);
 }
 #endif
+#endif /* XXX SP3 */
 
 #if LINUX_VERSION_CODE < KERNEL_VERSION(3,9,0)
 /*
--- a/backport-include/linux/netdevice.h
+++ b/backport-include/linux/netdevice.h
@@ -154,6 +154,7 @@ static inline int ndo_do_ioctl(struct ne
 }
 #endif
 
+#if 0 /* XXX SP3 */
 #if LINUX_VERSION_CODE < KERNEL_VERSION(3,3,0)
 /*
  * BQL was added as of v3.3 but some Linux distributions
@@ -197,6 +198,7 @@ static inline void netdev_reset_queue(st
 }
 #endif /* CONFIG_BQL */
 #endif /* < 3.3 */
+#endif /* XXX SP3 */
 
 #if LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
 /*
--- a/compat/compat-3.7.c
+++ b/compat/compat-3.7.c
@@ -45,10 +45,12 @@ static inline u16 pcie_flags_reg(struct
 	return reg16;
 }
 
+#if 0 /* XXX SP3 */
 static inline int pci_pcie_type(struct pci_dev *dev)
 {
 	return (pcie_flags_reg(dev) & PCI_EXP_FLAGS_TYPE) >> 4;
 }
+#endif /* XXX SP3 */
 
 static inline int pcie_cap_version(struct pci_dev *dev)
 {
@@ -124,6 +126,7 @@ static bool pcie_capability_reg_implemen
 	}
 }
 
+#if 0 /* XXX SP3 */
 /*
  * Note that these accessor functions are only for the "PCI Express
  * Capability" (see PCIe spec r3.0, sec 7.8).  They do not apply to the
@@ -251,3 +254,4 @@ int pcie_capability_clear_and_set_dword(
 	return ret;
 }
 EXPORT_SYMBOL_GPL(pcie_capability_clear_and_set_dword);
+#endif /* XXX SP3 */
--- a/backport-include/linux/device.h
+++ b/backport-include/linux/device.h
@@ -28,6 +28,7 @@ typedef int (backport_device_find_functi
 	dev_printk(KERN_CRIT , dev , format , ## arg)
 #endif
 
+#if 0 /* XXX SP3 */
 #if LINUX_VERSION_CODE < KERNEL_VERSION(3,3,0)
 /**
  * module_driver() - Helper macro for drivers that don't do anything
@@ -50,6 +51,7 @@ static void __exit __driver##_exit(void)
 } \
 module_exit(__driver##_exit);
 #endif
+#endif /* XXX SP3 */
 
 #if LINUX_VERSION_CODE < KERNEL_VERSION(3,9,0)
 #define devm_ioremap_resource LINUX_BACKPORT(devm_ioremap_resource)
--- a/backport-include/linux/etherdevice.h
+++ b/backport-include/linux/etherdevice.h
@@ -36,6 +36,7 @@ static inline void eth_hw_addr_random(st
 	random_ether_addr(dev->dev_addr);
 }
 
+#if 0 /* XXX SP3 */
 #elif LINUX_VERSION_CODE < KERNEL_VERSION(3,4,0)
 #define eth_hw_addr_random LINUX_BACKPORT(eth_hw_addr_random)
 static inline void eth_hw_addr_random(struct net_device *dev)
@@ -43,6 +44,7 @@ static inline void eth_hw_addr_random(st
 	dev_hw_addr_random(dev, dev->dev_addr);
 }
 #endif
+#endif /* XXX SP3 */
 
 #if LINUX_VERSION_CODE < KERNEL_VERSION(3,6,0)
 #include <linux/random.h>
@@ -57,6 +59,7 @@ static inline void eth_broadcast_addr(u8
 	memset(addr, 0xff, ETH_ALEN);
 }
 
+#if 0 /* XXX SP3 */
 /**
  * eth_random_addr - Generate software assigned random Ethernet address
  * @addr: Pointer to a six-byte array containing the Ethernet address
@@ -70,6 +73,7 @@ static inline void eth_random_addr(u8 *a
 	addr[0] &= 0xfe;        /* clear multicast bit */
 	addr[0] |= 0x02;        /* set local assignment bit (IEEE802) */
 }
+#endif /* XXX SP3 */
 #endif
 
 #if LINUX_VERSION_CODE < KERNEL_VERSION(3,7,0)
--- a/backport-include/linux/fs.h
+++ b/backport-include/linux/fs.h
@@ -8,10 +8,12 @@
  */
 #include <linux/uidgid.h>
 
+#if 0 /* XXX SP3 */
 #if (LINUX_VERSION_CODE < KERNEL_VERSION(3,4,0))
 #define simple_open LINUX_BACKPORT(simple_open)
 extern int simple_open(struct inode *inode, struct file *file);
 #endif
+#endif /* XXX SP3 */
 
 #if LINUX_VERSION_CODE < KERNEL_VERSION(3,9,0)
 /**
--- a/compat/compat-3.4.c
+++ b/compat/compat-3.4.c
@@ -345,6 +345,7 @@ void compat_wake_up_locked(wait_queue_he
 EXPORT_SYMBOL_GPL(compat_wake_up_locked);
 
 
+#if 0 /* XXX SP3 */
 #if (LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,34))
 #include <linux/i2c.h>
 #include <linux/i2c-algo-bit.h>
@@ -786,7 +787,9 @@ const struct i2c_algorithm i2c_bit_algo
 };
 EXPORT_SYMBOL_GPL(i2c_bit_algo);
 #endif
+#endif /* XXX SP3 */
 
+#if 0 /* XXX SP3 */
 int simple_open(struct inode *inode, struct file *file)
 {
 	if (inode->i_private)
@@ -794,3 +797,4 @@ int simple_open(struct inode *inode, str
 	return 0;
 }
 EXPORT_SYMBOL_GPL(simple_open);
+#endif /* XXX SP3 */
--- a/backport-include/linux/mii.h
+++ b/backport-include/linux/mii.h
@@ -3,6 +3,7 @@
 #include_next <linux/mii.h>
 #include <linux/version.h>
 
+#if 0 /* XXX SP3 */
 #if LINUX_VERSION_CODE < KERNEL_VERSION(3,3,0)
 #include <linux/ethtool.h>
 
@@ -143,5 +144,6 @@ static inline u32 mii_lpa_to_ethtool_lpa
 	return result | mii_adv_to_ethtool_adv_x(lpa);
 }
 #endif
+#endif /* XXX SP3 */
 
 #endif /* __BACKPORT_LINUX_MII_H */
--- a/backport-include/linux/pagemap.h
+++ b/backport-include/linux/pagemap.h
@@ -3,6 +3,7 @@
 #include_next <linux/pagemap.h>
 #include <linux/version.h>
 
+#if 0 /* XXX SP3 */
 #if LINUX_VERSION_CODE < KERNEL_VERSION(3,5,0)
 #include <asm/uaccess.h>
 /*
@@ -72,5 +73,6 @@ static inline int fault_in_multipages_re
         return ret;
 }
 #endif /* < 3.5 */
+#endif /* XXX SP3 */
 
 #endif /* __BACKPORT_LINUX_PAGEMAP_H */
--- a/backport-include/linux/skbuff.h
+++ b/backport-include/linux/skbuff.h
@@ -11,8 +11,10 @@ extern void v2_6_28_skb_add_rx_frag(stru
 #define skb_add_rx_frag(skb, i, page, off, size, truesize) \
 	v2_6_28_skb_add_rx_frag(skb, i, page, off, size)
 #elif (LINUX_VERSION_CODE < KERNEL_VERSION(3,4,0))
+#if 0 /* XXX SP3 */
 #define skb_add_rx_frag(skb, i, page, off, size, truesize) \
 	skb_add_rx_frag(skb, i, page, off, size)
+#endif /* XXX SP3 */
 #endif
 
 #if LINUX_VERSION_CODE < KERNEL_VERSION(3,3,0)
--- a/backport-include/linux/vga_switcheroo.h
+++ b/backport-include/linux/vga_switcheroo.h
@@ -3,6 +3,7 @@
 #if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,34)
 #include_next <linux/vga_switcheroo.h>
 
+#if 0 /* XXX SP3 */
 #if LINUX_VERSION_CODE < KERNEL_VERSION(3,5,0)
 /*
  * This backports:
@@ -38,6 +39,7 @@ static inline int compat_vga_switcheroo_
 	compat_vga_switcheroo_register_client(_dev, _ops)
 
 #endif /* < 3.5 */
+#endif /* XXX SP3 */
 
 #endif /* >= 2.6.34 */
 #endif /* __BACKPORT_VGA_SWITCHEROO_H */
--- a/backport-include/linux/wait.h
+++ b/backport-include/linux/wait.h
@@ -11,10 +11,12 @@
  * 	sched/wait: Add __wake_up_all_locked() API
  */
 
+#if 0 /* XXX SP3 */
 #ifndef wake_up_all_locked
 extern void compat_wake_up_locked(wait_queue_head_t *q, unsigned int mode, int nr);
 #define wake_up_all_locked(x)	compat_wake_up_locked((x), TASK_NORMAL, 0)
 #endif
+#endif /* XXX SP3 */
 
 #if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,28)
 #define wake_up_interruptible_poll(x, m)			\
--- a/backport-include/linux/kref.h
+++ b/backport-include/linux/kref.h
@@ -3,6 +3,7 @@
 #include_next <linux/kref.h>
 #include <linux/version.h>
 
+#if 0 /* XXX SP3 */
 #if LINUX_VERSION_CODE < KERNEL_VERSION(3,8,0)
 #include <linux/atomic.h>
 
@@ -22,5 +23,6 @@ static inline int __must_check kref_get_
 	return atomic_add_unless(&kref->refcount, 1, 0);
 }
 #endif
+#endif /* XXX SP3 */
 
 #endif /* __BACKPORT_KREF_H */
--- a/backport-include/linux/watchdog.h
+++ b/backport-include/linux/watchdog.h
@@ -2,9 +2,11 @@
 #define __BACKPORT_WATCHDOG_H
 #include_next <linux/watchdog.h>
 
+#if 0 /* XXX SP3 */
 #if LINUX_VERSION_CODE < KERNEL_VERSION(3,1,0)
 struct watchdog_device {
 };
 #endif
+#endif /* XXX SP3 */
 
 #endif /* __BACKPORT_WATCHDOG_H */